diff -r -c -b -N cosmomc/source/cmbtypes.F90 cosmomc_wiggles/source/cmbtypes.F90
*** cosmomc/source/cmbtypes.F90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_wiggles/source/cmbtypes.F90	2009-10-28 16:33:32.348968827 +0100
***************
*** 0 ****
--- 1,429 ----
+ !Define the data types and read/writes them to disk. Also change l_max here.
+ 
+ module cmbtypes
+ use settings
+ implicit none
+ 
+ 
+ !Number of Cls, 1 for just temperature, 3 (4) for polarization (with B)
+ !wig
+   integer, parameter  :: num_cls  = 4
+ !end wig
+ !l_max. Tensors are not computed unless compute_tensors = T in input file
+ !Make these multiples of 50, should be 50 more than you need accurately
+   integer, parameter :: lmax = 2100, lmax_tensor = 400
+ 
+ !Parameters for calculating/storing the matter power spectrum
+ !Note that by default everything is linear
+ !Old mpk settings
+ #ifdef DR71RG
+ !!! BR09: Reid et al 2009 settings for the LRG power spectrum.
+   integer, parameter :: num_matter_power = 300 !number of points computed in matter power spectrum
+   real, parameter    :: matter_power_minkh =  0.999e-4  !minimum value of k/h to store
+   real, parameter    :: matter_power_dlnkh = 0.03     !log spacing in k/h
+   real, parameter    :: matter_power_maxz = 0.
+   integer, parameter :: matter_power_lnzsteps = 4  ! z=0 to get sigma8 (this first entry appears to be coded in some spots in the code!!), plus 3 LRG redshifts.
+ #else
+   integer, parameter :: num_matter_power = 74 !number of points computed in matter power spectrum
+   real, parameter    :: matter_power_minkh =  0.999e-4  !1e-4 !minimum value of k/h to store
+   real, parameter    :: matter_power_dlnkh = 0.143911568     !log spacing in k/h
+   real, parameter    :: matter_power_maxz = 0.    !6.0
+   integer, parameter :: matter_power_lnzsteps = 1 !20
+ #endif
+ !Only used in params_CMB
+    real :: pivot_k = 0.05 !Point for defining primordial power spectra
+    logical :: inflation_consistency = .false. !fix n_T or not
+ 
+         !Note these are the interpolated/extrapolated values. The k at which matter power is computed up to 
+         !by CAMB is set in CMB_Cls_xxx with, e.g. P%Transfer%kmax = 0.6 (which is enough for 2dF)
+ 
+ !Number of scalar-only cls
+ !if num_cls=4 and CMB_lensing then increased to 4 
+   integer :: num_clsS=min(num_cls,3) 
+ 
+   integer, parameter :: norm_As=1, norm_amp_ratio=2, norm_freq_ix = 3
+   
+   Type CMBParams
+      real nuisance(1:num_nuisance_params)
+       !unit Gaussians for experimental parameters
+      real norm(1:num_norm)
+       !These are fast parameters controling amplitudes, calibrations, etc.
+      real InitPower(1:num_initpower)
+       !These are fast paramters for the initial power spectrum
+      !Now remaining (non-independent) parameters
+      real omb, omc, omv, omnu, omk, omdm
+      real ombh2, omch2, omnuh2, omdmh2
+      real zre, nufrac
+      real h, H0
+      real w
+      real reserved(5)
+   
+   end Type CMBParams
+ 
+   Type CosmoTheory
+      real Age, r10
+      real SN_loglike, HST_loglike, BAO_loglike, reserved(1)
+      real cl(lmax,num_cls), cl_tensor(lmax_tensor,num_cls) !TT, TE, EE and BB  in that order
+      real sigma_8
+      real matter_power(num_matter_power,matter_power_lnzsteps)
+        !second index is redshifts from 0 to matter_power_maxz
+        !if custom_redshift_steps = false with equal spacing in
+        !log(1+z) and matter_power_lnzsteps points
+        !if custom_redshift_steps = true set in mpk.f90 
+      ! BR09 additions
+      real mpk_nw(num_matter_power,matter_power_lnzsteps) !no wiggles fit to matter power spectrum
+      real mpkrat_nw_nl(num_matter_power,matter_power_lnzsteps) !halofit run on mpk_nw
+      real finalLRGtheoryPk(num_matter_power)  !! this is the quantity that enters the LRG likelihood calculation
+     ! end BR09 additions
+   end Type CosmoTheory
+ 
+   logical, parameter ::  Old_format  = .false.
+ !wig
+ !  logical, parameter :: write_all_Cls = .false. 
+   logical, parameter :: write_all_Cls = .true.
+ !end wig
+    !if false use CAMB's flat interpolation scheme (lossless if models are flat except near lmax when lensed)
+ 
+ contains
+ 
+ 
+    subroutine WriteModel(i,CMB, T, like, mult)
+     integer i
+     real, intent(in), optional :: mult
+     Type(CosmoTheory) T
+     real like, amult
+     Type(CMBParams) CMB
+     integer j 
+ 
+     if (present(mult)) then
+        amult = mult
+     else
+        amult = 1
+     end if
+     
+     if (Old_format) then
+ 
+       stop 'old not supported'    
+     else
+ 
+     j = 0 !format ID
+     if (write_all_cls) j=1
+     write(i) j
+ 
+     write(i) amult, num_matter_power, lmax, lmax_tensor, num_cls
+ 
+     write(i) T%SN_loglike, T%HST_loglike, T%reserved
+ 
+     write(i) like
+     write(i) CMB
+ 
+     write(i) T%Age, T%r10, T%sigma_8, T%matter_power
+ 
+     if (write_all_cls) then
+      write(i) T%cl(2:lmax,1:num_cls)
+      write(i) T%cl_tensor(2:lmax_tensor,1:num_cls)
+     else
+ 
+        !Use interpolation scheme CAMB uses for flat models
+        !If using significantly non-flat, or increasing interpolation accuracy, save all th cls instead
+         write(i) T%cl(2:20,1:num_cls)
+         do j=30,90,10 
+          write(i) T%cl(j,1:num_cls)
+         end do
+         do j=110,130, 20
+          write(i) T%cl(j,1:num_cls)
+         end do
+         do j=150,lmax, 50
+          write(i) T%cl(j,1:num_cls)
+         end do
+ 
+         if (lmax_tensor /= 0) then
+             if (lmax_tensor<150) stop 'lmax_tensor too small'
+             write(i) T%cl_tensor(2:20,1:num_cls)
+             do j=30,90,10 
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+             do j=110,130,20 
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+             do j=150,lmax_tensor, 50
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+         end if
+     end if
+ 
+     end if 
+ 
+     if (flush_write) call FlushFile(i)
+ 
+    end subroutine WriteModel
+ 
+    
+  subroutine ReadModel(i,CMB, T, mult, like, error)
+     integer, intent(in) :: i
+     integer, intent(out) :: error
+     real, intent(out) :: mult
+     Type(CosmoTheory) T
+     real like
+     Type(CMBParams) CMB
+     real icl(lmax,1:num_cls)
+     integer allcl,j,ind, ix(lmax)
+     integer almax,almaxtensor, anumpowers, anumcls
+    
+     error = 0
+ 
+     if (old_format) then
+ 
+        stop 'old not supported'
+ 
+     else
+ 
+         read(i,end=100,err=100) allcl
+ 
+         if (allcl/=0 .and. allcl/=1) stop 'wrong file format'
+ 
+         read(i,end=100,err=100) mult,anumpowers,almax, almaxtensor, anumcls
+         if (almax > lmax) stop 'reading file with larger lmax'
+         if (anumcls > num_cls) stop 'reading file with more Cls (polarization)'
+ 
+         read(i) T%SN_loglike, T%HST_loglike,T%reserved
+    
+         read(i,end = 100, err=100) like
+         read(i) CMB
+ 
+     
+         read(i) T%Age, T%r10, T%sigma_8, T%matter_power(1:anumpowers,1:matter_power_lnzsteps)
+         T%cl = 0
+         T%cl_tensor = 0
+          
+         if(allcl==1) then  
+          read(i) T%cl(2:almax,1:anumcls)
+          read(i) T%cl_tensor(2:almaxtensor,1:anumcls)
+         else
+ 
+             read(i) icl(1:19,1:num_cls)
+             ind =1
+             do j =2,20 
+                ix(ind)=j
+                ind=ind+1
+             end do
+             do j=30,90,10 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+              do j=110,130,20 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=150,almax, 50
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind+1
+             end do
+             ind = ind-1
+  
+            call InterpCls(ix,icl, T%cl, ind, almax, num_Cls)
+ 
+            if (almaxtensor /= 0) then     
+             read(i) icl(1:19,1:num_cls)
+             ind =1
+             do j =2,20 
+                ix(ind)=j
+                ind=ind+1
+             end do
+             do j=30,90,10 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=110,130,20 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=150,almaxtensor, 50
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind+1
+             end do
+             ind = ind-1
+             call InterpCls(ix,icl, T%cl_tensor, ind, almaxtensor,num_cls)
+            end if
+         
+         end if 
+ 
+         return
+     100 error = 1
+ 
+     end if
+ 
+    end subroutine ReadModel
+ 
+       subroutine InterpCls(l,iCl, all_Cl, n, almax, ncls)
+       integer, intent(in) :: n, almax,ncls
+    
+       real, intent(in) :: iCl(lmax,1:num_cls)
+       integer l(n),p
+       real all_Cl(:,:)
+    
+       integer il,llo,lhi,xi
+       real xl(n),  ddCl(n)
+ 
+       real a0,b0,ho
+       real inCl(n)
+ 
+     
+       do p =1, ncls
+ 
+         do il=1,n
+            inCl(il) = iCl(il,p)*l(il)**2
+         end do
+ 
+         xl = l
+         call spline_real(xl,inCl,n,ddCl)
+      
+         llo=1
+         do il=2,l(n)
+            xi=il
+            if ((xi > l(llo+1)).and.(llo < n)) then
+               llo=llo+1
+            end if
+            lhi=llo+1
+            ho=l(lhi)-l(llo)
+            a0=(xl(lhi)-xi)/ho
+            b0=(xi-xl(llo))/ho
+           
+            all_Cl(il,p) = (a0*inCl(llo)+ b0*inCl(lhi)+((a0**3-a0)* ddCl(llo) &
+                    +(b0**3-b0)*ddCl(lhi))*ho**2/6)/il**2
+   
+         end do
+ 
+       end do
+ 
+       all_Cl(l(n)+1:almax,:) = 0
+        
+ 
+       end subroutine InterpCls
+   
+   
+    subroutine ClsFromTheoryData(T, CMB, Cls)
+      Type(CosmoTheory) T
+      Type(CMBParams) CMB
+      real Cls(lmax,num_cls)
+      integer i
+      
+      Cls(2:lmax,1:num_clsS) =T%cl(2:lmax,1:num_clsS)    !CMB%norm(norm_As)*T%cl(2:lmax,1:num_clsS)
+      if (num_cls>3 .and. num_ClsS==3) Cls(2:lmax,num_cls)=0
+ 
+      i = norm_amp_ratio !this convolution is to avoid compile-time bounds-check errors on CMB%norm
+      if (CMB%norm(i) /= 0) then
+         Cls(2:lmax_tensor,:) =  Cls(2:lmax_tensor,:)+ T%cl_tensor(2:lmax_tensor,:) 
+          !CMB%norm(norm_As)*CMB%norm(norm_amp_ratio)*T%cl_tensor(2:lmax_tensor,:)
+      end if 
+ 
+    end subroutine ClsFromTheoryData
+ 
+    subroutine WriteTextCls(aname,T, CMB)
+      Type(CosmoTheory) T
+      Type(CMBParams) CMB
+      character (LEN=*), intent(in) :: aname
+      integer l
+      real Cls(lmax,num_cls)
+ 
+      call ClsFromTheoryData(T,CMB,Cls)
+      open(unit = tmp_file_unit, file = aname, form='formatted', status = 'replace')
+      do l=2, lmax
+         write (tmp_file_unit,*) l, Cls(l,:)*l*(l+1)/(2*pi)
+      end do
+      close(tmp_file_unit)
+ 
+    end subroutine WriteTextCls
+ 
+    function MatterPowerAt(T,kh)
+      !get matter power spectrum today at kh = k/h by interpolation from stored values
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real MatterPowerAt
+      real x, d
+      integer i
+    
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt (',kh,')'
+         stop 
+      end if
+      i = int(x)
+      d = x - i
+      MatterPowerAt = exp(log(T%matter_power(i+1,1))*(1-d) &
+        + log(T%matter_power(i+2,1))*d)
+      !Just do linear interpolation in logs for now..
+      !(since we already cublic-spline interpolated to get the stored values)
+      !Assume matter_power_lnzsteps is at redshift zero
+    end function
+ 
+ 
+ 
+ !BR09 this function is just a copy of the one above but with LRG theory put in instead of linear theory
+    function LRGPowerAt(T,kh)
+      !get LRG matter power spectrum today at kh = k/h by interpolation from stored values
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real LRGPowerAt
+      real x, d
+      integer i
+    
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt (',kh,')'
+         stop 
+      end if
+      i = int(x)
+      d = x - i
+      LRGPowerAt = exp(log(T%finalLRGtheoryPk(i+1))*(1-d) + log(T%finalLRGtheoryPk(i+2))*d)
+      !Just do linear interpolation in logs for now..
+      !(since we already cublic-spline interpolated to get the stored values)
+    end function
+ !!BRO09 addition end
+ 
+    function MatterPowerAt_Z(T,kh,z)
+      !get matter power spectrum at z at kh = k/h by interpolation from stored values
+ 
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real MatterPowerAt_Z
+      real x, d, z, y, dz, mup, mdn
+      real matter_power_dlnz
+      integer i, iz
+    
+      matter_power_dlnz = log(matter_power_maxz+1) / (matter_power_lnzsteps -1 + 1e-13)
+      y = log(1.+ z) / matter_power_dlnz 
+ 
+      if (z > matter_power_maxz ) then
+         write (*,*) ' z out of bounds in MatterPowerAt_Z (',z,')'
+         stop
+      end if
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt_Z (',kh,')'
+         stop
+      end if
+ 
+      iz = int(y*0.99999999)
+      dz = y - iz
+ 
+      i = int(x)
+      d = x - i
+ 
+      mup = log(T%matter_power(i+1,iz+2))*(1-d) + log(T%matter_power(i+2,iz+2))*d
+      mdn = log(T%matter_power(i+1,iz+1))*(1-d) + log(T%matter_power(i+2,iz+1))*d
+ 
+      MatterPowerAt_Z = exp(mdn*(1-dz) + mup*dz)
+ 
+    end function MatterPowerAt_Z
+ 
+ 
+ 
+ 
+ end module cmbtypes
diff -r -c -b -N cosmomc/source/driver.F90 cosmomc_wiggles/source/driver.F90
*** cosmomc/source/driver.F90	2009-10-20 15:24:17.000000000 +0200
--- cosmomc_wiggles/source/driver.F90	2009-10-28 16:36:09.328216523 +0100
***************
*** 58,68 ****
  
  #ifdef MPI 
  
!         if (instance /= 0) call DoStop('With MPI should not have second parameter')
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
  
          instance = MPIrank +1 !start at 1 for chains                                             
!         write (numstr,*) instance
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
--- 58,77 ----
  
  #ifdef MPI 
  
! !wig
! !        if (instance /= 0) call DoStop('With MPI should not have second parameter')
!         instance_shift=instance
!         write(*,*)'MPI file names shifted by: ',instance_shift
! !end wig
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
    
          instance = MPIrank +1 !start at 1 for chains                                             
! !wig
! !        write (numstr,*) instance
! 	instance_shift = MPIrank + instance_shift
! 	write (numstr,*) instance_shift
! !end wig
! 
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
***************
*** 85,90 ****
--- 94,106 ----
  
          propose_scale = Ini_Read_Real('propose_scale',2.4)
          AccuracyLevel = Ini_Read_Real('accuracy_level',1.)
+ !wig
+         lAccuracyLevel = Ini_Read_Real('l_accuracy_level',1.)
+         lSampleLevel = Ini_Read_Real('l_sample_level',1.)
+         kSrcSampleLevel = Ini_Read_Real('k_src_sample_level',1.)
+         kIntSampleLevel = Ini_Read_Real('k_int_sample_level',1.)
+         CambComputeEveryl = Ini_Read_Logical('camb_compute_every_l',.false.)
+ !end wig
  
          checkpoint = Ini_Read_Logical('checkpoint',.false.)
          if (checkpoint) flush_write = .true.
diff -r -c -b -N cosmomc/source/GetDist.f90 cosmomc_wiggles/source/GetDist.f90
*** cosmomc/source/GetDist.f90	2009-10-27 16:41:31.000000000 +0100
--- cosmomc_wiggles/source/GetDist.f90	2009-10-28 16:36:22.056208166 +0100
***************
*** 89,94 ****
--- 89,97 ----
          logical force_twotail 
          logical smoothing, plot_meanlikes, plot_NDcontours
          logical shade_meanlikes, make_single_samples
+ !addon
+         logical td_meanlikes
+ !end addon
          integer single_thin,cust2DPlots(max_cols**2)
          integer ix_min(max_cols),ix_max(max_cols)
          real center(max_cols),width(max_cols)   
***************
*** 1339,1351 ****
   !             write (aunit,fmt) (/(I, I=ix_min(j), ix_max(j), 1)/)*width(j)+center(j)
                if (DoShade) then
                if (shade_meanlikes) then
                  write (aunit,'(a)') "load (fullfile('"//trim(plot_data_dir)//"','" // trim(plotfile) //'_likes''));'
                  write (aunit,*) 'contourf(x1,x2,'//trim(plotfile)//'_likes,64);'
                else     
                  write (aunit,*) 'contourf(x1,x2,pts,64);'
                end if
! 
                write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
                end if
                
             
--- 1342,1370 ----
   !             write (aunit,fmt) (/(I, I=ix_min(j), ix_max(j), 1)/)*width(j)+center(j)
                if (DoShade) then
                if (shade_meanlikes) then
+ !addon
                  write (aunit,'(a)') "load (fullfile('"//trim(plot_data_dir)//"','" // trim(plotfile) //'_likes''));'
+                  if (td_meanlikes) then
+                     write (aunit,*) 'surfl(x1,x2,'//trim(plotfile)//'_likes);'
+                  else
                  write (aunit,*) 'contourf(x1,x2,'//trim(plotfile)//'_likes,64);'
+                  endif
+ !end addon
+ 
                else     
                  write (aunit,*) 'contourf(x1,x2,pts,64);'
                end if
! !addon
! !              write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
!               if (td_meanlikes) then
!                  write (aunit,*) 'set(gca,''climmode'',''manual'');shading interp; hold on;'
!                  write (aunit,*) 'grid off;box on;camproj(''perspective'');'
!                  write (aunit,*) 'set(gca,''climmode'',''manual'');alpha(0.9);axis tight'
!               else
                write (aunit,*) 'set(gca,''climmode'',''manual''); shading flat; hold on;'
+               endif
+ !end addon
+ 
                end if
                
             
***************
*** 1762,1767 ****
--- 1781,1789 ----
            write (*,*) 'WARNING: Mapping params - .covmat file is new params.'
  
      shade_meanlikes = Ini_Read_Logical('shade_meanlikes',.false.)   
+ !addon
+     td_meanlikes = Ini_Read_Logical('td_meanlikes',.false.)  
+ !end addon
  
      matlab_col = Ini_Read_String('matlab_colscheme')
      smoothing = Ini_Read_Logical('smoothing',.true.)
***************
*** 2435,2441 ****
--- 2457,2470 ----
                write (51,*)  'set(gcf, ''PaperUnits'',''inches'');'
       
                if (plot_row < plot_col .and. plot_row*plot_col>9) then
+ !addon
+ !            write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          if (td_meanlikes) then
+             write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 7 9]);';
+          else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 10]);';
+          endif
+ !end addon           
                else
                  write (51,*) 'set(gcf, ''PaperPosition'',[ 0 0 8 8]);';
                end if
diff -r -c -b -N cosmomc/source/lrggettheory.F90 cosmomc_wiggles/source/lrggettheory.F90
*** cosmomc/source/lrggettheory.F90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_wiggles/source/lrggettheory.F90	2009-10-28 16:49:31.960218537 +0100
***************
*** 0 ****
--- 1,189 ----
+ !!! moved this routine from modules.f90 in CAMB here by preference of Antony.
+ !!! needs to be separate from Pktheory.f90 because that file depends on CMB_Cls somehow
+ 
+ module lrggettheory
+ use precision
+ use Transfer
+ implicit none
+ 
+ real(dl), parameter ::  aNEAR = 0.809717d0, aMID = 0.745156d0, aFAR = 0.70373d0
+ real(dl), parameter ::  z0 = 0.0d0, zNEAR = 0.235d0, zMID = 0.342d0, zFAR = 0.421d0
+ real(dl), parameter ::  sigma2BAONEAR = 86.9988, sigma2BAOMID = 85.1374, sigma2BAOFAR = 84.5958
+ real(dl), parameter :: zeffDR7 = 0.312782  !! effective redshift of the LRG sample
+ real(dl), dimension(4) :: transferscalefid  !! this is set in LRGinfo_init
+ real(dl), dimension(4) :: powerscaletoz0  
+  !! this is to scale the amplitude of the redshift slices power spectra to the z=0 amplitude; 
+  !this is the assumption of the model.
+ real(dl), parameter :: kmindata = 0.02 
+  !! in h/Mpc.  they are needed for normalizing nowiggs power spectrum. 
+ ! Hard coded for the SDSS DR7 values.
+ integer :: iz0lrg, izNEARlrg, izMIDlrg, izFARlrg
+ logical :: use_dr7lrg = .false.  
+ 
+ contains
+ 
+         subroutine Transfer_GetMatterPowerAndNW(MTrans,outpower, itf, in, minkh, dlnkh, &
+                 npoints, kmindata, getabstransferscale, outpowernw, outpowerrationwhalofit)
+ 
+           !Allows for non-smooth priordial spectra
+           !if CP%Nonlinear/ = NonLinear_none includes non-linear evolution
+           !Get total matter power spectrum at logarithmically equal intervals dlnkh of k/h starting at minkh
+           !in units of (h Mpc^{-1})^3.
+           !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
+           !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
+           !sepctrum is generated to beyond the CMB k_max
+           Type(MatterTransferData), intent(in) :: MTrans
+           Type(MatterPowerData) :: PKnw
+ 
+           integer, intent(in) :: itf, in, npoints 
+           real, intent(out) :: outpower(npoints)
+           real, intent(out) :: outpowernw(npoints), outpowerrationwhalofit(npoints)
+           real, intent(in) :: minkh, dlnkh
+           real(dl), intent(in) :: kmindata
+           real(dl), intent(out) :: getabstransferscale
+           real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl
+           integer ik, llo,il,lhi,lastix
+           real(dl) matpower(MTrans%num_q_trans), kh, kvals(MTrans%num_q_trans), ddmat(MTrans%num_q_trans)
+           real(dl) atransfer,xi, a0, b0, ho, logmink,k, h, fbaryon,omegam
+           real(dl) matpowernw(MTrans%num_q_trans), matpowernwhalofit(MTrans%num_q_trans), &
+           & atransfernw, atransfernwhalofit, &
+           &ddmatnw(MTrans%num_q_trans), ddmatnwhalofit(MTrans%num_q_trans)
+ 
+           !!added for splining.
+           real(dl) :: mykvals(MTrans%num_q_trans),mylnpklinear(MTrans%num_q_trans),mylnpksmooth(MTrans%num_q_trans)
+ 
+           integer :: nwi,tempi, setabs
+           Type(MatterTransferData) :: MTransnw
+ 
+           MTransnw%num_q_trans = MTrans%num_q_trans
+           allocate(MTransnw%q_trans(MTransnw%num_q_trans))
+           allocate(MTransnw%TransferData(Transfer_max,MTransnw%num_q_trans,CP%Transfer%num_redshifts))
+           allocate(MTransnw%sigma_8(CP%Transfer%num_redshifts, CP%InitPower%nn))
+ 
+ 
+           h = CP%H0/100
+           do nwi = 1, MTransnw%num_q_trans
+             MTransnw%q_trans(nwi) = MTrans%q_trans(nwi)  !! not ever referenced.
+             MTransnw%TransferData(Transfer_kh,nwi,1) = MTrans%TransferData(Transfer_kh,nwi,1)
+             kh = MTrans%TransferData(Transfer_kh,nwi,1)
+             k = kh*h
+             do tempi=2,Transfer_tot
+               MTransnw%TransferData(tempi,nwi,1) = 0.0d0
+             end do
+             mykvals(nwi) = k
+             atransfer=MTrans%TransferData(transfer_power_var,nwi,itf)
+             mylnpklinear(nwi) = log(atransfer**2*k*pi*twopi*h**3*ScalarPower(k,in))
+           end do
+ 
+ #ifdef DR71RG
+           call dopksmoothbspline(mykvals,mylnpklinear,mylnpksmooth, MTrans%num_q_trans)
+ #else
+          call MpiStop('mpk: edit makefile to have "EXTDATA = LRG" to inlude LRGs')
+ #endif
+           setabs = 0
+           do nwi = 1, MTransnw%num_q_trans
+             kh = MTrans%TransferData(Transfer_kh,nwi,1)
+             if(kh > kmindata .and. setabs == 0) then
+               getabstransferscale = sqrt(exp(mylnpklinear(nwi)))
+               setabs = 1
+            end if
+             k = kh*h
+             MTransnw%TransferData(transfer_power_var,nwi,1) = sqrt(exp(mylnpksmooth(nwi))/(k*pi*twopi*h**3*ScalarPower(k,in)))
+           end do
+           if (npoints < 2) stop 'Need at least 2 points in Transfer_GetMatterPower'
+           if (minkh*exp((npoints-1)*dlnkh) > MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf) &
+                 .and. FeedbackLevel > 0 ) &
+                     write(*,*) 'Warning: extrapolating matter power in Transfer_GetMatterPower'
+ 
+           !! get nonlinear on Pnw
+           call Transfer_GetMatterPowerData(MTransnw,PKnw, in, 1)
+           Pknw%redshifts(1) = CP%Transfer%Redshifts(itf)
+           call NonLinear_GetRatios(Pknw)
+ 
+           h = CP%H0/100
+           logmink = log(minkh)
+           do ik=1,MTrans%num_q_trans
+              kh = MTrans%TransferData(Transfer_kh,ik,itf)
+              k = kh*h
+              kvals(ik) = log(kh)
+              atransfer=MTrans%TransferData(transfer_power_var,ik,itf)
+              atransfernw=MTransnw%TransferData(transfer_power_var,ik,1)
+              atransfernwhalofit=MTransnw%TransferData(transfer_power_var,ik,1)
+              atransfernwhalofit = atransfernwhalofit * PKnw%nonlin_ratio(ik,1)
+              matpower(ik) = log(atransfer**2*k*pi*twopi*h**3)
+                  !Put in power spectrum later: transfer functions should be smooth, initial power may not be
+ 
+              matpowernw(ik) = log(atransfernw**2*k*pi*twopi*h**3)
+              matpowernwhalofit(ik) = log(atransfernwhalofit**2*k*pi*twopi*h**3)
+           end do
+           call spline(kvals,matpower,MTrans%num_q_trans,cllo,clhi,ddmat)
+           call spline(kvals,matpowernw,MTrans%num_q_trans,cllo,clhi,ddmatnw)
+           call spline(kvals,matpowernwhalofit,MTrans%num_q_trans,cllo,clhi,ddmatnwhalofit)
+ 
+ 
+             llo=1
+             lastix = npoints + 1
+             do il=1, npoints
+                xi=logmink + dlnkh*(il-1)
+                if (xi < kvals(1)) then
+                  outpower(il)=-30.
+                  outpowernw(il)=-30.
+                  outpowerrationwhalofit(il)=-30.
+                  cycle
+                end if
+                do while ((xi > kvals(llo+1)).and.(llo < MTrans%num_q_trans))
+                   llo=llo+1
+                   if (llo >= MTrans%num_q_trans) exit
+                end do
+                if (llo == MTrans%num_q_trans) then
+                    lastix = il
+                    exit
+                end if
+                lhi=llo+1
+                ho=kvals(lhi)-kvals(llo)
+                a0=(kvals(lhi)-xi)/ho
+                b0=(xi-kvals(llo))/ho
+ 
+                outpower(il) = a0*matpower(llo)+ b0*matpower(lhi)+((a0**3-a0)* ddmat(llo) &
+                        +(b0**3-b0)*ddmat(lhi))*ho**2/6
+                outpowernw(il) = a0*matpowernw(llo)+ b0*matpowernw(lhi)+((a0**3-a0)* ddmatnw(llo) &
+                        +(b0**3-b0)*ddmatnw(lhi))*ho**2/6
+                outpowerrationwhalofit(il) = a0*matpowernwhalofit(llo)+ b0*matpowernwhalofit(lhi)+((a0**3-a0)* ddmatnwhalofit(llo) &
+                        +(b0**3-b0)*ddmatnwhalofit(lhi))*ho**2/6
+ 
+             end do
+ 
+             do while (lastix <= npoints)
+                !Do linear extrapolation in the log
+                !Obviouly inaccurate, non-linear etc, but OK if only using in tails of window functions
+                outpower(lastix) = 2*outpower(lastix-1) - outpower(lastix-2)
+                outpowernw(lastix) = 2*outpowernw(lastix-1) - outpowernw(lastix-2)
+                outpowerrationwhalofit(lastix) = 2*outpowerrationwhalofit(lastix-1)&
+                          - outpowerrationwhalofit(lastix-2)
+                lastix = lastix+1
+             end do
+ 
+             outpower = exp(max(-30.,outpower))
+             outpowernw = exp(max(-30.,outpowernw))
+             outpowerrationwhalofit = exp(max(-30.,outpowerrationwhalofit))
+ 
+ 
+             do il = 1, npoints
+                k = exp(logmink + dlnkh*(il-1))*h
+                outpower(il) = outpower(il) * ScalarPower(k,in)
+                outpowerrationwhalofit(il) = outpowerrationwhalofit(il)/outpowernw(il) 
+                 !! do this first because the ScalarPower calls cancel.
+                outpowernw(il) = outpowernw(il) * ScalarPower(k,in)
+                !print *,k/h,outpower(il),outpowernw(il)
+                !print *,k/h,outpowerrationwhalofit(il)
+             end do
+ 
+           call MatterPowerdata_Free(PKnw)
+           deallocate(MTransnw%q_trans)
+           deallocate(MTransnw%TransferData)
+           deallocate(MTransnw%sigma_8)
+ 
+         end subroutine Transfer_GetMatterPowerAndNW
+ 
+ 
+ end module
